<?php
class controller_block_bootstrap_carousel_slider extends block {
	
	public function action_index($module_info) {
		$this->data['settings'] = unserialize($module_info['params']);
		$this->page['head'] = $this->add_css_file(SITE_URL.'/modules/blocks/bootstrap_carousel_slider/views/style.css');
		$this->page['html'] = $this->load_view();
		return $this->page;
	}

	protected function settings($submit_name, $settings) {
		$errors = Array();

		if (isset($_POST[$submit_name])) {

			$settings['has_previews'] = isset($_POST['has_previews']);
			$settings['has_arrows'] = isset($_POST['has_arrows']);
			$settings['has_indicators'] = isset($_POST['has_indicators']);
			$settings['aspect_ratio'] = floatval(str_replace(',', '.', $_POST['aspect_ratio']));

			if ($settings['aspect_ratio'] <= 0.0) $errors[] = 'Соотношение сторон задано неверно';

			$max_key = 0;
			foreach ($_POST['images'] as $key => $image) {
				if (is_uploaded_file($_FILES['files']['tmp_name'][$key])) {
					$new_image = '/uploads/images/carousel/'.$_FILES['files']['name'][$key];
					if (move_uploaded_file($_FILES['files']['tmp_name'][$key], ROOT_DIR.$new_image)) {
						if ($image != '' && file_exists(ROOT_DIR.$image)) unlink(ROOT_DIR.$image);
						$settings['slides'][$key]['image'] = $new_image;
					} else {
						$errors[] = 'Ошибка загрузки: '.$_FILES['files'][$key]['name'];
					}
				} else {
					$settings['slides'][$key]['image'] = $image;
				}

				$settings['slides'][$key]['text'] = $_POST['texts'][$key];
				$settings['slides'][$key]['btn_text'] = $_POST['btn_texts'][$key];
				$settings['slides'][$key]['href'] = $_POST['hrefs'][$key];
				$max_key = $key;
			}

			$l = count($settings['slides']);
			for ($i = $max_key+1; $i < $l; $i++) {
				$image = $settings['slides'][$i]['image'];
				if ($image != '' && file_exists(ROOT_DIR.$image)) unlink(ROOT_DIR.$image);
				unset($settings['slides'][$i]);
			}

			if (empty($errors)) {
				$this->page['params'] = serialize($settings);
			} else {
				unset($_POST[$submit_name]);
			}

		}

		$this->data['errors'] = $errors;
		$this->data['settings'] = $settings;
		$this->page['html'] = $this->load_view('settings');
		return $this->page;
	}

	public function action_activate() {
		return $this->settings('activate', Array(
			'has_previews' => false,
			'has_arrows' => true,
			'has_indicators' => true,
			'aspect_ratio' => 1.33,
			'slides' => Array()
		));
	}

	public function action_settings($module_info) {
		return $this->settings('edit_settings', unserialize($module_info['params']));
	}

}
?>